class
	P_PCRE_GET_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public routines

	pcre_get_stringnumber (a_code: CE_POINTER [ANY]; a_stringname: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_rc: INTEGER_32
			l_entrysize: CE_ARRAY [INTEGER_32]
			l_top: CE_ARRAY [INTEGER_32]
			l_bot: INTEGER_32
			l_nametable: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_mid: INTEGER_32
			l_entry: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_entrysize.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_top.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_nametable.make (<<1>>)

			l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 8, create {CE_VOID_POINTER}.make_cast (l_top)))
			if l_rc /= 0 then
				Result := l_rc
				l_return := True
			end
			if not l_return and then (l_top.item <= 0) then
				Result := (-7)
				l_return := True
			end
			if not l_return then
				l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 7, create {CE_VOID_POINTER}.make_cast (l_entrysize)))
				if l_rc /= 0 then
					Result := l_rc
					l_return := True
				end
			end
			if not l_return then
				l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 9, create {CE_VOID_POINTER}.make_cast (l_nametable)))
				if l_rc /= 0 then
					Result := l_rc
					l_return := True
				end
			end
			if not l_return then
				l_bot := 0
				from
				until
					not (not (l_return) and then (l_top.item > l_bot))
				loop
					l_mid := (l_top.item + l_bot) // 2
					l_entry := l_nametable.item + l_entrysize.item * l_mid
					l_c := (strcmp (a_stringname, create {CE_INTEGER_8_POINTER}.make_cast ((l_entry + 2))))
					if l_c = 0 then
						Result := ((((((l_entry[0]).to_integer_32).bit_shift_left (8))).bit_or ((l_entry[1]).to_integer_32)).to_natural_32).to_integer_32
						l_return := True
					end
					if not l_return then
						if l_c > 0 then
							l_bot := l_mid + 1
						else
							l_top.item := l_mid
						end
					end
				end
			end
			if not l_return then
				Result := (-7)
			end
		end

	pcre_get_stringtable_entries (a_code: CE_POINTER [ANY]; a_stringname: CE_POINTER [INTEGER_8]; a_firstptr, a_lastptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_rc: INTEGER_32
			l_entrysize: CE_ARRAY [INTEGER_32]
			l_top: CE_ARRAY [INTEGER_32]
			l_bot: INTEGER_32
			l_nametable: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lastentry: CE_POINTER [NATURAL_8]
			l_mid: INTEGER_32
			l_entry: CE_POINTER [NATURAL_8]
			l_c: INTEGER_32
			l_first: CE_POINTER [NATURAL_8]
			l_last: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_entrysize.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_top.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_nametable.make (<<1>>)

			l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 8, create {CE_VOID_POINTER}.make_cast (l_top)))
			if l_rc /= 0 then
				Result := l_rc
				l_return := True
			end
			if not l_return and then (l_top.item <= 0) then
				Result := (-7)
				l_return := True
			end
			if not l_return then
				l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 7, create {CE_VOID_POINTER}.make_cast (l_entrysize)))
				if l_rc /= 0 then
					Result := l_rc
					l_return := True
				end
			end
			if not l_return then
				l_rc := ((create {P_PCRE_FULLINFO_STATIC}).pcre_fullinfo (a_code, create {CE_CLASS_POINTER [PD_PCRE_EXTRA]}.make_shared (default_pointer), 9, create {CE_VOID_POINTER}.make_cast (l_nametable)))
				if l_rc /= 0 then
					Result := l_rc
					l_return := True
				end
			end
			if not l_return then
				l_lastentry := l_nametable.item + l_entrysize.item * (l_top.item - 1)
				l_bot := 0
				from
				until
					not (not (l_return) and then (l_top.item > l_bot))
				loop
					l_mid := (l_top.item + l_bot) // 2
					l_entry := l_nametable.item + l_entrysize.item * l_mid
					l_c := (strcmp (a_stringname, create {CE_INTEGER_8_POINTER}.make_cast ((l_entry + 2))))
					if l_c = 0 then
						l_first := l_entry
						l_last := l_entry
						from
						until
							not (not (l_break) and then ((l_first.c_pointer.to_integer_32).to_natural_32 > ((l_nametable.item).c_pointer.to_integer_32).to_natural_32))
						loop
							l_break := False
							if (strcmp (a_stringname, create {CE_INTEGER_8_POINTER}.make_cast (((l_first - l_entrysize.item) + 2)))) /= 0 then
								l_break := True
							end
							if not (l_break) then
								l_first := l_first - (l_entrysize.item)
							end
						end
						l_break := False
						from
						until
							not (not (l_break) and then ((l_last.c_pointer.to_integer_32).to_natural_32 < (l_lastentry.c_pointer.to_integer_32).to_natural_32))
						loop
							l_break := False
							if (strcmp (a_stringname, create {CE_INTEGER_8_POINTER}.make_cast (((l_last + l_entrysize.item) + 2)))) /= 0 then
								l_break := True
							end
							if not (l_break) then
								l_last := l_last + (l_entrysize.item)
							end
						end
						l_break := False
						a_firstptr.item := create {CE_INTEGER_8_POINTER}.make_cast (l_first)
						a_lastptr.item := create {CE_INTEGER_8_POINTER}.make_cast (l_last)
						Result := (l_entrysize.item)
						l_return := True
					end
					if not l_return then
						if l_c > 0 then
							l_bot := l_mid + 1
						else
							l_top.item := l_mid
						end
					end
				end
			end
			if not l_return then
				Result := (-7)
			end
		end

	get_first_set (a_code: CE_POINTER [ANY]; a_stringname: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_re: CE_POINTER [PD_REAL_PCRE8_OR_16]
			l_entrysize: INTEGER_32
			l_entry: CE_POINTER [NATURAL_8]
			l_first: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_last: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_POINTER} l_entry.make
			create {CE_POINTER_ARRAY [INTEGER_8]} l_first.make (<<1>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_last.make (<<1>>)

			l_re := create {CE_CLASS_POINTER [PD_REAL_PCRE8_OR_16]}.make_cast (a_code)
			if ((l_re.item.options).bit_and ({NATURAL_32} 524_288)) = {NATURAL_32} 0 then
				if (((l_re.item.flags).to_integer_32).bit_and (1_024)) = 0 then
					Result := (pcre_get_stringnumber (a_code, a_stringname))
					l_return := True
				end
			end
			if not l_return then
				l_entrysize := (pcre_get_stringtable_entries (a_code, a_stringname, l_first, l_last))
				if l_entrysize <= 0 then
					Result := l_entrysize
					l_return := True
				end
			end
			if not l_return then
				l_entry := create {CE_NATURAL_8_POINTER}.make_cast (l_first.item)
				from
				until
					not (not (l_return) and then ((l_entry.c_pointer.to_integer_32).to_natural_32 <= ((create {CE_NATURAL_8_POINTER}.make_cast (l_last.item)).c_pointer.to_integer_32).to_natural_32))
				loop
					l_n := ((((((l_entry[0]).to_integer_32).bit_shift_left (8))).bit_or ((l_entry[1]).to_integer_32)).to_natural_32).to_integer_32
					if a_ovector[l_n * 2] >= 0 then
						Result := l_n
						l_return := True
					end
					if not l_return then
						l_entry := l_entry + l_entrysize
					end
				end
			end
			if not l_return then
				Result := ((((((l_entry[0]).to_integer_32).bit_shift_left (8))).bit_or ((l_entry[1]).to_integer_32)).to_natural_32).to_integer_32
			end
		end

	pcre_copy_substring (a_subject: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]; a_stringcount, a_stringnumber: INTEGER_32; a_buffer: CE_POINTER [INTEGER_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_stringnumber: INTEGER_32
			l_yield: INTEGER_32
			l_return: BOOLEAN
		do
			l_stringnumber := a_stringnumber
			if l_stringnumber < 0 then
				Result := (-7)
				l_return := True
			elseif l_stringnumber >= a_stringcount then
				Result := (-7)
				l_return := True
			end
			if not l_return then
				l_stringnumber := l_stringnumber * (2)
				l_yield := a_ovector[(l_stringnumber + 1)] - a_ovector[l_stringnumber]
				if a_size < l_yield + 1 then
					Result := (-6)
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (a_buffer), create {CE_VOID_POINTER}.make_cast ((a_subject + a_ovector[l_stringnumber])), l_yield.to_natural_32).do_nothing
				a_buffer[l_yield] := (0).to_integer_8
				Result := l_yield
			end
		end

	pcre_copy_named_substring (a_code: CE_POINTER [ANY]; a_subject: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]; a_stringcount: INTEGER_32; a_stringname, a_buffer: CE_POINTER [INTEGER_8]; a_size: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := (get_first_set (a_code, a_stringname, a_ovector))
			if l_n <= 0 then
				Result := l_n
				l_return := True
			end
			if not l_return then
				Result := (pcre_copy_substring (a_subject, a_ovector, a_stringcount, l_n, a_buffer, a_size))
			end
		end

	pcre_get_substring_list (a_subject: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]; a_stringcount: INTEGER_32; a_listptr: CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]): INTEGER_32
		local
			l_i: INTEGER_32
			l_size: INTEGER_32
			l_double_count: INTEGER_32
			l_stringlist: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_p: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_tmp_0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_tmp_1: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_size := ({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32
			l_double_count := a_stringcount * 2
			l_i := 0
			from
			until
				not (l_i < l_double_count)
			loop
				l_size := (l_size.to_natural_32 + ({PLATFORM}.Pointer_bytes.to_natural_32 + ((a_ovector[(l_i + 1)] - a_ovector[l_i]) + 1).to_natural_32)).to_integer_32
				l_i := l_i + (2)
			end
			l_stringlist := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (malloc (l_size.to_natural_32))
			if l_stringlist.is_void then
				Result := (-6)
				l_return := True
			end
			if not l_return then
				a_listptr.item := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_stringlist)
				l_p := create {CE_NATURAL_8_POINTER}.make_cast (((l_stringlist + a_stringcount) + 1))
				l_i := 0
				from
				until
					not (l_i < l_double_count)
				loop
					l_len := a_ovector[(l_i + 1)] - a_ovector[l_i]
					memcpy (create {CE_VOID_POINTER}.make_cast (l_p), create {CE_VOID_POINTER}.make_cast ((a_subject + a_ovector[l_i])), l_len.to_natural_32).do_nothing
					l_tmp_0 := l_stringlist
					l_stringlist := l_stringlist + 1
					l_tmp_0.item := l_p
					l_p := l_p + l_len
					l_tmp_1 := l_p
					l_p := l_p + 1
					l_tmp_1.item := (0).to_natural_8
					l_i := l_i + (2)
				end
				l_stringlist.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				Result := 0
			end
		end

	pcre_free_substring_list (a_pointer: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			free (a_pointer)
		end

	pcre_get_substring (a_subject: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]; a_stringcount, a_stringnumber: INTEGER_32; a_stringptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_stringnumber: INTEGER_32
			l_yield: INTEGER_32
			l_substring: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_NATURAL_8_POINTER} l_substring.make

			l_stringnumber := a_stringnumber
			if l_stringnumber < 0 then
				Result := (-7)
				l_return := True
			elseif l_stringnumber >= a_stringcount then
				Result := (-7)
				l_return := True
			end
			if not l_return then
				l_stringnumber := l_stringnumber * (2)
				l_yield := a_ovector[(l_stringnumber + 1)] - a_ovector[l_stringnumber]
				l_substring := create {CE_NATURAL_8_POINTER}.make_cast (malloc ((l_yield + 1).to_natural_32))
				if l_substring.is_void then
					Result := (-6)
					l_return := True
				end
			end
			if not l_return then
				memcpy (create {CE_VOID_POINTER}.make_cast (l_substring), create {CE_VOID_POINTER}.make_cast ((a_subject + a_ovector[l_stringnumber])), l_yield.to_natural_32).do_nothing
				l_substring[l_yield] := (0).to_natural_8
				a_stringptr.item := create {CE_INTEGER_8_POINTER}.make_cast (l_substring)
				Result := l_yield
			end
		end

	pcre_get_named_substring (a_code: CE_POINTER [ANY]; a_subject: CE_POINTER [INTEGER_8]; a_ovector: CE_POINTER [INTEGER_32]; a_stringcount: INTEGER_32; a_stringname: CE_POINTER [INTEGER_8]; a_stringptr: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := (get_first_set (a_code, a_stringname, a_ovector))
			if l_n <= 0 then
				Result := l_n
				l_return := True
			end
			if not l_return then
				Result := (pcre_get_substring (a_subject, a_ovector, a_stringcount, l_n, a_stringptr))
			end
		end

	pcre_free_substring (a_pointer: CE_POINTER [INTEGER_8])
		do
			free (a_pointer)
		end

end
