class
	PD_EPTRBLOCK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_EPTRBLOCK]} epb_prev.make
			create {CE_NATURAL_8_POINTER} epb_saved_eptr.make
		end

	make_initialized (a_data: TUPLE [
				a_epb_prev: CE_POINTER [PD_EPTRBLOCK]
				a_epb_saved_eptr: CE_POINTER [NATURAL_8]
			])
		do
			epb_prev := a_data.a_epb_prev
			epb_saved_eptr := a_data.a_epb_saved_eptr
		end

feature {ANY} -- fields

	epb_prev: CE_POINTER [PD_EPTRBLOCK] assign set__epb_prev

	epb_saved_eptr: CE_POINTER [NATURAL_8] assign set__epb_saved_eptr

feature {ANY} -- field setters

	set__epb_prev (a_epb_prev: CE_POINTER [PD_EPTRBLOCK])
		do
			epb_prev := a_epb_prev
			update_memory_field ("epb_prev")
		end

	set__epb_saved_eptr (a_epb_saved_eptr: CE_POINTER [NATURAL_8])
		do
			epb_saved_eptr := a_epb_saved_eptr
			update_memory_field ("epb_saved_eptr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			epb_prev := a_other.epb_prev
			epb_saved_eptr := a_other.epb_saved_eptr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				epb_prev.is_equal (a_other.epb_prev) and
				epb_saved_eptr.is_equal (a_other.epb_saved_eptr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("epb_prev"),
					create {CE_STRUCTURE_FIELD}.make ("epb_saved_eptr")
				>>)
			init_structure_info
		end

end
