class
	PD_PCRE_EXTRA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} study_data.make
			create {CE_VOID_POINTER} callout_data.make
			create {CE_NATURAL_8_POINTER} tables.make
			create {CE_POINTER_POINTER [NATURAL_8]} mark.make
			create {CE_VOID_POINTER} executable_jit.make
		end

	make_initialized (a_data: TUPLE [
				a_flags: NATURAL_32
				a_study_data: CE_POINTER [ANY]
				a_match_limit: NATURAL_32
				a_callout_data: CE_POINTER [ANY]
				a_tables: CE_POINTER [NATURAL_8]
				a_match_limit_recursion: NATURAL_32
				a_mark: CE_POINTER [CE_POINTER [NATURAL_8]]
				a_executable_jit: CE_POINTER [ANY]
			])
		do
			flags := a_data.a_flags
			study_data := a_data.a_study_data
			match_limit := a_data.a_match_limit
			callout_data := a_data.a_callout_data
			tables := a_data.a_tables
			match_limit_recursion := a_data.a_match_limit_recursion
			mark := a_data.a_mark
			executable_jit := a_data.a_executable_jit
		end

feature {ANY} -- fields

	flags: NATURAL_32 assign set__flags

	study_data: CE_POINTER [ANY] assign set__study_data

	match_limit: NATURAL_32 assign set__match_limit

	callout_data: CE_POINTER [ANY] assign set__callout_data

	tables: CE_POINTER [NATURAL_8] assign set__tables

	match_limit_recursion: NATURAL_32 assign set__match_limit_recursion

	mark: CE_POINTER [CE_POINTER [NATURAL_8]] assign set__mark

	executable_jit: CE_POINTER [ANY] assign set__executable_jit

feature {ANY} -- field setters

	set__flags (a_flags: NATURAL_32)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set__study_data (a_study_data: CE_POINTER [ANY])
		do
			study_data := a_study_data
			update_memory_field ("study_data")
		end

	set__match_limit (a_match_limit: NATURAL_32)
		do
			match_limit := a_match_limit
			update_memory_field ("match_limit")
		end

	set__callout_data (a_callout_data: CE_POINTER [ANY])
		do
			callout_data := a_callout_data
			update_memory_field ("callout_data")
		end

	set__tables (a_tables: CE_POINTER [NATURAL_8])
		do
			tables := a_tables
			update_memory_field ("tables")
		end

	set__match_limit_recursion (a_match_limit_recursion: NATURAL_32)
		do
			match_limit_recursion := a_match_limit_recursion
			update_memory_field ("match_limit_recursion")
		end

	set__mark (a_mark: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			mark := a_mark
			update_memory_field ("mark")
		end

	set__executable_jit (a_executable_jit: CE_POINTER [ANY])
		do
			executable_jit := a_executable_jit
			update_memory_field ("executable_jit")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			flags := a_other.flags
			study_data := a_other.study_data
			match_limit := a_other.match_limit
			callout_data := a_other.callout_data
			tables := a_other.tables
			match_limit_recursion := a_other.match_limit_recursion
			mark := a_other.mark
			executable_jit := a_other.executable_jit
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				flags = a_other.flags and
				study_data.is_equal (a_other.study_data) and
				match_limit = a_other.match_limit and
				callout_data.is_equal (a_other.callout_data) and
				tables.is_equal (a_other.tables) and
				match_limit_recursion = a_other.match_limit_recursion and
				mark.is_equal (a_other.mark) and
				executable_jit.is_equal (a_other.executable_jit)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("study_data"),
					create {CE_STRUCTURE_FIELD}.make ("match_limit"),
					create {CE_STRUCTURE_FIELD}.make ("callout_data"),
					create {CE_STRUCTURE_FIELD}.make ("tables"),
					create {CE_STRUCTURE_FIELD}.make ("match_limit_recursion"),
					create {CE_STRUCTURE_FIELD}.make ("mark"),
					create {CE_STRUCTURE_FIELD}.make ("executable_jit")
				>>)
			init_structure_info
		end

end
