class
	PD_REAL_PCRE8_OR_16

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} tables.make
			create {CE_NATURAL_8_POINTER} nullpad.make
		end

	make_initialized (a_data: TUPLE [
				a_magic_number: NATURAL_32
				a_size: NATURAL_32
				a_options: NATURAL_32
				a_flags: NATURAL_16
				a_max_lookbehind: NATURAL_16
				a_top_bracket: NATURAL_16
				a_top_backref: NATURAL_16
				a_first_char: NATURAL_16
				a_req_char: NATURAL_16
				a_name_table_offset: NATURAL_16
				a_name_entry_size: NATURAL_16
				a_name_count: NATURAL_16
				a_ref_count: NATURAL_16
				a_tables: CE_POINTER [NATURAL_8]
				a_nullpad: CE_POINTER [NATURAL_8]
			])
		do
			magic_number := a_data.a_magic_number
			size := a_data.a_size
			options := a_data.a_options
			flags := a_data.a_flags
			max_lookbehind := a_data.a_max_lookbehind
			top_bracket := a_data.a_top_bracket
			top_backref := a_data.a_top_backref
			first_char := a_data.a_first_char
			req_char := a_data.a_req_char
			name_table_offset := a_data.a_name_table_offset
			name_entry_size := a_data.a_name_entry_size
			name_count := a_data.a_name_count
			ref_count := a_data.a_ref_count
			tables := a_data.a_tables
			nullpad := a_data.a_nullpad
		end

feature {ANY} -- fields

	magic_number: NATURAL_32 assign set__magic_number

	size: NATURAL_32 assign set__size

	options: NATURAL_32 assign set__options

	flags: NATURAL_16 assign set__flags

	max_lookbehind: NATURAL_16 assign set__max_lookbehind

	top_bracket: NATURAL_16 assign set__top_bracket

	top_backref: NATURAL_16 assign set__top_backref

	first_char: NATURAL_16 assign set__first_char

	req_char: NATURAL_16 assign set__req_char

	name_table_offset: NATURAL_16 assign set__name_table_offset

	name_entry_size: NATURAL_16 assign set__name_entry_size

	name_count: NATURAL_16 assign set__name_count

	ref_count: NATURAL_16 assign set__ref_count

	tables: CE_POINTER [NATURAL_8] assign set__tables

	nullpad: CE_POINTER [NATURAL_8] assign set__nullpad

feature {ANY} -- field setters

	set__magic_number (a_magic_number: NATURAL_32)
		do
			magic_number := a_magic_number
			update_memory_field ("magic_number")
		end

	set__size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

	set__options (a_options: NATURAL_32)
		do
			options := a_options
			update_memory_field ("options")
		end

	set__flags (a_flags: NATURAL_16)
		do
			flags := a_flags
			update_memory_field ("flags")
		end

	set__max_lookbehind (a_max_lookbehind: NATURAL_16)
		do
			max_lookbehind := a_max_lookbehind
			update_memory_field ("max_lookbehind")
		end

	set__top_bracket (a_top_bracket: NATURAL_16)
		do
			top_bracket := a_top_bracket
			update_memory_field ("top_bracket")
		end

	set__top_backref (a_top_backref: NATURAL_16)
		do
			top_backref := a_top_backref
			update_memory_field ("top_backref")
		end

	set__first_char (a_first_char: NATURAL_16)
		do
			first_char := a_first_char
			update_memory_field ("first_char")
		end

	set__req_char (a_req_char: NATURAL_16)
		do
			req_char := a_req_char
			update_memory_field ("req_char")
		end

	set__name_table_offset (a_name_table_offset: NATURAL_16)
		do
			name_table_offset := a_name_table_offset
			update_memory_field ("name_table_offset")
		end

	set__name_entry_size (a_name_entry_size: NATURAL_16)
		do
			name_entry_size := a_name_entry_size
			update_memory_field ("name_entry_size")
		end

	set__name_count (a_name_count: NATURAL_16)
		do
			name_count := a_name_count
			update_memory_field ("name_count")
		end

	set__ref_count (a_ref_count: NATURAL_16)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

	set__tables (a_tables: CE_POINTER [NATURAL_8])
		do
			tables := a_tables
			update_memory_field ("tables")
		end

	set__nullpad (a_nullpad: CE_POINTER [NATURAL_8])
		do
			nullpad := a_nullpad
			update_memory_field ("nullpad")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			magic_number := a_other.magic_number
			size := a_other.size
			options := a_other.options
			flags := a_other.flags
			max_lookbehind := a_other.max_lookbehind
			top_bracket := a_other.top_bracket
			top_backref := a_other.top_backref
			first_char := a_other.first_char
			req_char := a_other.req_char
			name_table_offset := a_other.name_table_offset
			name_entry_size := a_other.name_entry_size
			name_count := a_other.name_count
			ref_count := a_other.ref_count
			tables := a_other.tables
			nullpad := a_other.nullpad
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				magic_number = a_other.magic_number and
				size = a_other.size and
				options = a_other.options and
				flags = a_other.flags and
				max_lookbehind = a_other.max_lookbehind and
				top_bracket = a_other.top_bracket and
				top_backref = a_other.top_backref and
				first_char = a_other.first_char and
				req_char = a_other.req_char and
				name_table_offset = a_other.name_table_offset and
				name_entry_size = a_other.name_entry_size and
				name_count = a_other.name_count and
				ref_count = a_other.ref_count and
				tables.is_equal (a_other.tables) and
				nullpad.is_equal (a_other.nullpad)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("magic_number"),
					create {CE_STRUCTURE_FIELD}.make ("size"),
					create {CE_STRUCTURE_FIELD}.make ("options"),
					create {CE_STRUCTURE_FIELD}.make ("flags"),
					create {CE_STRUCTURE_FIELD}.make ("max_lookbehind"),
					create {CE_STRUCTURE_FIELD}.make ("top_bracket"),
					create {CE_STRUCTURE_FIELD}.make ("top_backref"),
					create {CE_STRUCTURE_FIELD}.make ("first_char"),
					create {CE_STRUCTURE_FIELD}.make ("req_char"),
					create {CE_STRUCTURE_FIELD}.make ("name_table_offset"),
					create {CE_STRUCTURE_FIELD}.make ("name_entry_size"),
					create {CE_STRUCTURE_FIELD}.make ("name_count"),
					create {CE_STRUCTURE_FIELD}.make ("ref_count"),
					create {CE_STRUCTURE_FIELD}.make ("tables"),
					create {CE_STRUCTURE_FIELD}.make ("nullpad")
				>>)
			init_structure_info
		end

end
