class
	PD_RECURSION_INFO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_RECURSION_INFO]} prevrec.make
			create {CE_INTEGER_32_POINTER} offset_save.make
			create {CE_NATURAL_8_POINTER} subject_position.make
		end

	make_initialized (a_data: TUPLE [
				a_prevrec: CE_POINTER [PD_RECURSION_INFO]
				a_group_num: NATURAL_32
				a_offset_save: CE_POINTER [INTEGER_32]
				a_saved_max: INTEGER_32
				a_subject_position: CE_POINTER [NATURAL_8]
			])
		do
			prevrec := a_data.a_prevrec
			group_num := a_data.a_group_num
			offset_save := a_data.a_offset_save
			saved_max := a_data.a_saved_max
			subject_position := a_data.a_subject_position
		end

feature {ANY} -- fields

	prevrec: CE_POINTER [PD_RECURSION_INFO] assign set__prevrec

	group_num: NATURAL_32 assign set__group_num

	offset_save: CE_POINTER [INTEGER_32] assign set__offset_save

	saved_max: INTEGER_32 assign set__saved_max

	subject_position: CE_POINTER [NATURAL_8] assign set__subject_position

feature {ANY} -- field setters

	set__prevrec (a_prevrec: CE_POINTER [PD_RECURSION_INFO])
		do
			prevrec := a_prevrec
			update_memory_field ("prevrec")
		end

	set__group_num (a_group_num: NATURAL_32)
		do
			group_num := a_group_num
			update_memory_field ("group_num")
		end

	set__offset_save (a_offset_save: CE_POINTER [INTEGER_32])
		do
			offset_save := a_offset_save
			update_memory_field ("offset_save")
		end

	set__saved_max (a_saved_max: INTEGER_32)
		do
			saved_max := a_saved_max
			update_memory_field ("saved_max")
		end

	set__subject_position (a_subject_position: CE_POINTER [NATURAL_8])
		do
			subject_position := a_subject_position
			update_memory_field ("subject_position")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			prevrec := a_other.prevrec
			group_num := a_other.group_num
			offset_save := a_other.offset_save
			saved_max := a_other.saved_max
			subject_position := a_other.subject_position
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				prevrec.is_equal (a_other.prevrec) and
				group_num = a_other.group_num and
				offset_save.is_equal (a_other.offset_save) and
				saved_max = a_other.saved_max and
				subject_position.is_equal (a_other.subject_position)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("prevrec"),
					create {CE_STRUCTURE_FIELD}.make ("group_num"),
					create {CE_STRUCTURE_FIELD}.make ("offset_save"),
					create {CE_STRUCTURE_FIELD}.make ("saved_max"),
					create {CE_STRUCTURE_FIELD}.make ("subject_position")
				>>)
			init_structure_info
		end

end
