class
	PD_VERBITEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make_initialized (a_data: TUPLE [
				a_len: INTEGER_32
				a_op: INTEGER_32
				a_op_arg: INTEGER_32
			])
		do
			len := a_data.a_len
			op := a_data.a_op
			op_arg := a_data.a_op_arg
		end

feature {ANY} -- fields

	len: INTEGER_32 assign set__len

	op: INTEGER_32 assign set__op

	op_arg: INTEGER_32 assign set__op_arg

feature {ANY} -- field setters

	set__len (a_len: INTEGER_32)
		do
			len := a_len
			update_memory_field ("len")
		end

	set__op (a_op: INTEGER_32)
		do
			op := a_op
			update_memory_field ("op")
		end

	set__op_arg (a_op_arg: INTEGER_32)
		do
			op_arg := a_op_arg
			update_memory_field ("op_arg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			len := a_other.len
			op := a_other.op
			op_arg := a_other.op_arg
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				len = a_other.len and
				op = a_other.op and
				op_arg = a_other.op_arg
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("len"),
					create {CE_STRUCTURE_FIELD}.make ("op"),
					create {CE_STRUCTURE_FIELD}.make ("op_arg")
				>>)
			init_structure_info
		end

end
